"""empty message

Revision ID: cab1403436ff
Revises: 531c633b5d0b
Create Date: 2021-07-21 11:39:41.539398

"""
from typing import Optional

import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision: str = "cab1403436ff"
down_revision: Optional[str] = "531c633b5d0b"
branch_labels: Optional[str] = None
depends_on: Optional[str] = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "metatranscriptome",
        sa.Column("id", sa.String(), nullable=False),
        sa.Column("name", sa.String(), nullable=False),
        sa.Column("type", sa.String(), nullable=False),
        sa.Column("git_url", sa.String(), nullable=False),
        sa.Column("started_at_time", sa.DateTime(), nullable=False),
        sa.Column("ended_at_time", sa.DateTime(), nullable=False),
        sa.Column("execution_resource", sa.String(), nullable=False),
        sa.Column("omics_processing_id", sa.String(), nullable=False),
        sa.ForeignKeyConstraint(
            ["omics_processing_id"],
            ["omics_processing.id"],
            name=op.f("fk_metatranscriptome_omics_processing_id_omics_processing"),
        ),
        sa.PrimaryKeyConstraint("id", name=op.f("pk_metatranscriptome")),
    )
    op.create_table(
        "metatranscriptome_input_association",
        sa.Column("metatranscriptome_id", sa.String(), nullable=True),
        sa.Column("data_object_id", sa.String(), nullable=True),
        sa.ForeignKeyConstraint(
            ["data_object_id"],
            ["data_object.id"],
            name=op.f("fk_metatranscriptome_input_association_data_object_id_data_object"),
        ),
        sa.ForeignKeyConstraint(
            ["metatranscriptome_id"],
            ["metatranscriptome.id"],
            name=op.f(
                "fk_metatranscriptome_input_association_metatranscriptome_id_metatranscriptome"
            ),
        ),
        sa.UniqueConstraint(
            "metatranscriptome_id",
            "data_object_id",
            name=op.f("uq_metatranscriptome_input_association_metatranscriptome_id"),
        ),
    )
    op.create_table(
        "metatranscriptome_output_association",
        sa.Column("metatranscriptome_id", sa.String(), nullable=True),
        sa.Column("data_object_id", sa.String(), nullable=True),
        sa.ForeignKeyConstraint(
            ["data_object_id"],
            ["data_object.id"],
            name=op.f("fk_metatranscriptome_output_association_data_object_id_data_object"),
        ),
        sa.ForeignKeyConstraint(
            ["metatranscriptome_id"],
            ["metatranscriptome.id"],
            name=op.f(
                "fk_metatranscriptome_output_association_metatranscriptome_id_metatranscriptome"
            ),
        ),
        sa.UniqueConstraint(
            "metatranscriptome_id",
            "data_object_id",
            name=op.f("uq_metatranscriptome_output_association_metatranscriptome_id"),
        ),
    )
    op.create_unique_constraint(op.f("uq_envo_ancestor_id"), "envo_ancestor", ["id", "ancestor_id"])
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(op.f("uq_envo_ancestor_id"), "envo_ancestor", type_="unique")
    op.drop_table("metatranscriptome_output_association")
    op.drop_table("metatranscriptome_input_association")
    op.drop_table("metatranscriptome")
    # ### end Alembic commands ###
